﻿
// Pulled from http://stackoverflow.com/questions/647259/javascript-query-string
function getQueryString() {
    var result = {}, queryString = location.search.substring(1), re = /([^&=]+)=([^&]*)/g, m;
    while (m = re.exec(queryString)) {
        result[decodeURIComponent(m[1])] = decodeURIComponent(m[2]);
    }

    return result;
}

// Add IE class to the html element if ie.
// Needs to be done for IE10+ since conditional comments are out.
$(function () {
    if ($.browser.msie && $.browser.version == 10) {
        $('html').addClass('ie10').addClass('ie');
    }
});

// Adds a case insensitive, order insensitive ":contains" style filter for jQuery
(function ($) {

    $.expr[':'].ContainsInAnyOrder = function (a, i, m) {
        var parts = m[3].split(' ');
        var search = $(a).text().toUpperCase();

        for (var i in parts)
            if (!(search.indexOf(parts[i].toUpperCase()) >= 0))
                return false;

        return true;
    };

})($);


// footer height fix.
$(function () {
    var $body = $('body');
    var footerPadding = parseInt($('body').css('padding-bottom'));
    if ($body.outerHeight() < $(window).height()) $body.height($(window).height() - footerPadding);
});

/**
* Highlights the protected OMA content bullet point on the file formats page.
* This can be removed when Walkman has supplied a valid link for the OMA warning.
*/
$(function () {
    if ($('html.page-features-file-formats').size() > 0 && getQueryString()["protected-oma-not-supported"] !== undefined) {
        $li = $('li.oma-notice');
        $li.prependTo($li.parent()).addClass('highlight');
    }
});


// ---- Placeholder until 2.3 drop 3 comes back. 
// Front page panel re-ordering for non-JPN sites. Jason and Winona want "Connect your devices" ahead of "Discover New Content".
$(function () {
    $body = $('body');
    if ($body.hasClass('page-features') && !$body.hasClass('lang_jpn')) {
        $('div.feature-slab.discover-new-content').before($('div.feature-slab.connect-your-devices'));
    }
});

/**
* Submenu selected item fix.
* See CSS selector: section#sub-menu ul li.right-of-selected
*/
$(function () {
    $('section#sub-menu ul li.selected').next('li').addClass('right-of-selected');
});

/**
* Disable the menu and submenu selected items.
*/
$(function () {
    $('section#sub-menu ul li.selected a').click(function () { return false; });
});

/**
* Records the popularity of our FAQs
* See: /:langugage:/support/frequently-asked-questions
*/
$(function () {
    $('div.faq-page h5').click(function () {
        $h5 = $(this);
        $li = $h5.parents('li:first');

        if ($li.hasClass('open')) {
            $li.removeClass('open');
        } else {
            $li.addClass('open');
        }
    });
});

$(function () {
    if ($('html.page-support-frequently-asked-questions').size() == 0) return;
    var p = $('html.page-support-frequently-asked-questions span.placeholder').html();
    $('html.page-support-frequently-asked-questions .search-wrapper input').attr('placeholder', p);
});


/**
 * Acclaro 2.4 CHS layout bug fix
 */
$(function () {
    if ($('html.page-features-file-formats').size() == 0) return;
    $('.data-table tr td:nth-child(odd)').addClass('format');
    $('.data-table tr td:nth-child(even)').addClass('extension');
});


/**
* FAQ page search feature
* See: /:langugage:/support/frequently-asked-questions
*/
$(function () {

    var timeout = null;

    $('html.page-support-frequently-asked-questions .search input').keyup(function () {
        var $input = $(this);

        if (timeout != null)
            clearTimeout(timeout);

        timeout = setTimeout(function () {

            // Not searching? Make sure everything is visible
            if ($input.val() === '') {
                $('div.faqs').show().find('li').removeClass('search-match').removeClass('open').show();
                $('div.no-results').hide();
                return;
            }

            $('div.faq-page .faqs ul.faq-questions > li').removeClass('open').removeClass('search-match').hide().each(function () {
                if ($input.val() == '') {
                    $(this).show();
                    return;
                }

                if ($(this).is(":ContainsInAnyOrder('" + $input.val() + "')")) {
                    $(this).addClass('open').addClass('search-match').show();
                }
            });

            // Check if we have empty results.
            $('div.faqs:not(:has(li.search-match))').hide();
            $('div.faqs:has(li.search-match)').show();

            // Completely empty results? Show the user a message that their search didn't produce any results.
            $('div.no-results').toggle($('div.faqs:visible').size() === 0);

        }, 300);

    }).focus();

    $('html.page-support-frequently-asked-questions .search span a').click(function () {
        $(this).parents('div.search:first').find('input').val('').keyup().focus();
    });
});


/**
* Submits user feedback. 
*/
$(function () {
    $('html.page-support-feedback button#post-feedback').click(function () {

        $button = $(this);

        // check if we're already in the middle of a submit. 
        if ($button.data('submitting')) {
            return;
        }

        var url = SITE_CONFIG.baseUrl + "FeedbackProcessor/Process";
        var valid = true;
        var data = {
            language: SITE_CONFIG.language,
            feature: $('html.page-support-feedback textarea#feature').val(),
            where: $('html.page-support-feedback textarea#where').val(),
            benefit: $('html.page-support-feedback textarea#benefit').val()
        };

        _.each(['feature', 'where', 'benefit'], function (field) {
            if (!data[field]) {
                $('html.page-support-feedback p.error.' + field).fadeIn();
                valid = false;
            } else {
                $('html.page-support-feedback p.error.' + field).fadeOut();
            }
        });

        if (!valid) return;

        $button.data('submitting', true);
        $button.find('span.default').hide();
        $button.find('span.submitting').show();

        $.post(url, data, function (r) {
            setTimeout(function () {
                $button.data('submitting', false);
                $('html.page-support-feedback textarea').val('');
                $button.find('span.submitting').hide();
                $button.find('span.default').show();
                $('html.page-support-feedback .thank-you').fadeIn();
                setTimeout(function () { $('html.page-support-feedback .thank-you').fadeOut(); }, 20000);
            }, 800);
        }, 'json');

    });
});


/**
* Submits a podcat suggestion 
*/
$(function () {
    $('body.page-suggest-podcast button.btn').click(function () {

        $button = $(this);

        // check if we're already in the middle of a submit. 
        if ($button.data('submitting')) {
            return;
        }

        var url = SITE_CONFIG.baseUrl + "FeedbackProcessor/ProcessPodcastSuggestion";
        var data = {
            language: SITE_CONFIG.language,
            url: $('body.page-suggest-podcast input[name="url"]').val()
        };

        $button.data('submitting', true);
        $button.find('span.default').hide();
        $button.find('span.submitting').show();

        $.post(url, data, function (r) {
            setTimeout(function () {
                $button.data('submitting', false);
                $('.suggest-form input').val('');
                $button.find('span.submitting').hide();
                $button.find('span.default').show();
                $('.suggest-form .thank-you').fadeIn();
                setTimeout(function () { $('.suggest-form .thank-you').fadeOut(); }, 10000);
            }, 800);
        }, 'json');

    });
});


/**
 * Download Thank You Page
 */
$(function () {

    var $page = $('html.page-download-thank-you');
    if ($page.size() === 0) return;

    /**
    * Fix for locales which have not had theads/foots placed. 
    * Can be removed after Acclaro's second localization drop for 2.4.
    */
    $page.find('.strip-wrapper table').each(function () {
        if ($(this).find('thead').size() == 0) {
            $(this).prepend('<thead><tr><td></td></tr></thead>');
        }

        if ($(this).find('tfoot').size() == 0) {
            $(this).append('<tfoot><tr><td></td></tr></tfoot>');
        }
    });

    if (!$page.hasClass('lang_enu')) {
        $page.find('div.back-forth a').remove();
        $page.find('.strip-wrapper').prepend('<a href="javascript://" class="prev"><span></span></a>');
        $page.find('.strip-wrapper').append('<a href="javascript://" class="next"><span></span></a>');
    }

    /**
    * End temporary pre-drop-2 localization code.
    */

    // Remove the store tip block for locales in Media Go which do not support it. 
    var matches = /lang_([a-z]{3})/.exec($page.attr('class'));
    var locale = matches[1];
    var doesNotHaveStore = ['chs', 'cht', 'dan', 'fin', 'kor', 'nld', 'nor', 'plk', 'ptb', 'ptg', 'rus', 'sve'];
    if ($.inArray(locale, doesNotHaveStore) !== -1) {
        $page.find('.strip.s-1, .headings .h-1').addClass('skip');
        $page.find('.strip.s-2, .headings .h-2').css('display', 'block');
    } else {
        $page.find('.strip.s-1, .headings .h-1').css('display', 'block');
    }
    // End of store detection.

    setTimeout(function () {
        var redirect = $page.find('.intro a').attr('href');
        $('body footer nav').append('<iframe src="' + redirect + '" height="1" width"1" frameborder="0"></iframe>');
    }, 5000);


    var totalTips = $page.find('.strip').size();
    var $headings = $page.find('.back-forth .headings');
    var $stripWrapper = $page.find('.strip-wrapper');
    var transitioning = false;


    function showTip(tipNumber, direction, callback) {

        if (tipNumber < 1) tipNumber = totalTips;
        if (tipNumber > totalTips) tipNumber = 1;

        var otherDirection = direction === 'left' ? 'right' : 'left';

        var $currentH2 = $headings.find('h2:visible:first');
        var $nextH2 = $page.find('h2.h-' + tipNumber);
        var $currentStrip = $stripWrapper.find('.strip:visible');
        var $nextStrip = $stripWrapper.find('.s-' + tipNumber);

        // Right now the only reason for skipping is that the page's locale does not support the 
        // store within Media Go. 
        if ($nextStrip.hasClass('skip')) {
            var t = (direction === 'right') ? tipNumber - 1 : tipNumber + 1;
            showTip(t, direction, callback);
            return;
        }

        $currentH2.fadeOut();

        $currentStrip.hide('slide', { direction: direction }, 750, function () {
            $nextH2.fadeIn();
            $nextStrip.show('slide', { direction: otherDirection }, 750, callback);
        }, 'linear');

    }

    function getCurrentTip() {
        var $h2 = $headings.find('h2:visible:first');
        return parseInt($h2.attr('class').replace('h-', ''), 10);
    }

    $page.find('.strip-wrapper a:first').click(function () {
        // Prevent the user from furiously clicking on the back/forth buttons. 
        if (transitioning == true) return false;
        transitioning = true;
        showTip(getCurrentTip() - 1, 'right', function () { transitioning = false; });
        return false;
    });

    $page.find('.strip-wrapper a:last').click(function () {
        // Prevent the user from furiously clicking on the back/forth buttons. 
        if (transitioning == true) return false;
        transitioning = true;
        showTip(getCurrentTip() + 1, 'left', function () { transitioning = false; });
        return false;
    });

});


